# lowercase
lc = $(subst A,a,$(subst B,b,$(subst C,c,$(subst D,d,$(subst E,e,$(subst F,f,$(subst G,g,$(subst H,h,$(subst I,i,$(subst J,j,$(subst K,k,$(subst L,l,$(subst M,m,$(subst N,n,$(subst O,o,$(subst P,p,$(subst Q,q,$(subst R,r,$(subst S,s,$(subst T,t,$(subst U,u,$(subst V,v,$(subst W,w,$(subst X,x,$(subst Y,y,$(subst Z,z,$1))))))))))))))))))))))))))

REL_BUILD_DIR:=nexa/build_${PLATFORM}_${ARCH}
REL_LIGHTBUILD_DIR:=${REL_BUILD_DIR}/lightbuild
BUILD_DIR:=$(abspath ${REL_LIGHTBUILD_DIR})

# platform is PLATFORM lowercase
platform:=$(call lc,${PLATFORM})
$(warning platform is: ${platform})
all: build/${platform}/${ARCH}/libnexalight.so build/${platform}/${ARCH}/libnexalight.a

nexa/configure: nexa/configure.ac
	echo configure not needed because manually inserting nexa-config.h
	# (cd nexa; ./autogen.sh)

${REL_BUILD_DIR}: nexa/configure
	@echo Creating build directory: $@
	mkdir -p $@


${REL_BUILD_DIR}/config.status: nexa/configure
	@echo Creating build directory: ${REL_BUILD_DIR}
	mkdir -p ${REL_BUILD_DIR}
	# not needed because nexa-config.h provided
	# (cd nexa/${TARGET}; ../configure --host=${TARGET} CFLAGS=-fpic --disable-bench --disable-tests --with-gui=no --disable-wallet --enable-shared)

#nexa/${TARGET}/src/.libs/libnexa.so: nexa/${TARGET} nexa/${TARGET}/config.status
#	echo ${CC} ${CXX}; $(MAKE) -C nexa/${TARGET} V=1

#nexa/src/cashlib/nexa-config.h: nexa-config-macos.h
#	cp nexa-config-macos.h nexa/src/cashlib

# triggers cmake to create a makefile (DEPRECATED)
#nexa/${TARGET}/lightbuild/Makefile: nexa/src/cashlib/nexa-config.h nexa/src/cashlib/CMakeLists.txt nexa/${TARGET}/config.status
#	mkdir -p nexa/${TARGET}/lightbuild
#	(cd nexa/${TARGET}/lightbuild); cmake ../../src/cashlib)

# will build both .so and .a
${REL_LIGHTBUILD_DIR}/libnexalight.so: nexa/src/cashlib/nexa-config.h
	mkdir -p ${BUILD_DIR}
	BUILD_DIR=${BUILD_DIR} $(MAKE) -C nexa/src/cashlib ${BUILD_DIR}/libnexalight.so

${REL_LIGHTBUILD_DIR}/libnexalight.a: nexa/src/cashlib/nexa-config.h
	@echo deferring build of $@ to cashlib
	mkdir -p ${REL_LIGHTBUILD_DIR}
	BUILD_DIR=${BUILD_DIR} $(MAKE) -C nexa/src/cashlib ${BUILD_DIR}/libnexalight.a


#./build/android/${ARCH}/libnexalight.a: build/android/${ARCH} nexa/${TARGET}/lightbuild/libnexalight.so
#	cp nexa/${TARGET}/src/.libs/libnexalight.a build/android/${ARCH}/libnexalight.a

build/${platform}/${ARCH}/libnexalight.so: build/${platform}/${ARCH} ${REL_LIGHTBUILD_DIR}/libnexalight.so
	cp ${REL_LIGHTBUILD_DIR}/libnexalight.so build/${platform}/${ARCH}/libnexalight.so

build/${platform}/${ARCH}/libnexalight.a: build/${platform}/${ARCH} ${REL_LIGHTBUILD_DIR}/libnexalight.a
	cp ${REL_LIGHTBUILD_DIR}/libnexalight.a build/${platform}/${ARCH}/libnexalight.a

build/${platform}/${ARCH}:
	@echo creating output directory $@
	mkdir -p ./build/${platform}/${ARCH}


clean:
	rm -rf nexa/build_*
	rm -f nexa/src/cashlib/*.o
	rm -rf build

cleanall: clean
	-echo ""
